#define _GNU_SOURCE
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#include <sys/mman.h>

unsigned long get_stack_map(unsigned long end)
{
	FILE *f;
	unsigned long a, b;
	unsigned long ret = 0;
	char buffer[4096];
	f = fopen("/proc/self/maps", "r");
	while (fgets(buffer, sizeof(buffer), f)) {
		if (!strstr(buffer, "[stack]"))
			continue;
		puts(buffer);
		if (sscanf(buffer, "%lx-%lx", &a, &b) == 2) {
			if (a <= end && b >= end) {
				ret = a;
				break;
			}
		}
	}
	fclose(f);
	return ret;
}

#ifndef PAGE_SIZE
#define PAGE_SIZE 4096
#endif

int main(int argc, char **argv)
{
	unsigned long *end;
	unsigned char *base;
	unsigned long *map;
	end = (unsigned long *) &end;
	base = (unsigned char *) get_stack_map(*end);
	printf("%p 0x%lx\n", base, *end);
	map = mmap(base - PAGE_SIZE, PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_ANON|MAP_PRIVATE|MAP_FIXED, -1, 0);
	printf("mapped %p\n", map);
	base += PAGE_SIZE;
	*base = 0;
	return 0;
}
